# TE Technology, INC.
# Traverse City, Michigan
# https://tetech.com/
#
# Download TC-36-25-RS485 Manual for complete command set at the website below 
# https://tetech.com/product/tc-36-25-rs485/
# 
# Download the correct FTDI VCP drivers for your system at the website below
# http://www.ftdichip.com/Drivers/VCP.htm
# 
# This basic code is for setting the temperature on the TC-36-25-RS485 temperature controller 
# 
# Only works on Python 2.7 as of this time -- 9:39 AM June 11th, 2018
# 
# You will need to install the pyserial package to communicate through the port
# The line below is the pip install module command
# pip install pyserial

# You MUST switch OUTPUT from OFF to ON using the TC-36-25-RS485 Software
# Otherwise the cooler will not receive power


import serial
# send set temperature of -1.50 C
# see TC-36-25-RS485 Manual for command codes -- edit the line below to change the set temperature
bstc=['*','6','2','1','c','f','f','f','f','f','f','6','a','f','7','\r'] # characters in this line must be in lowercase
# stx relates to '*'
# the controller address is '6','2'
# the command code is '1','c'
# data being transmitted is 'f','f','f','f','f','f','6','a'
# checksum is 'f','7'
# return is '\r'

# read control sensor temp1
bst=['*','6','2','0','1','0','0','0','0','0','0','0','0','4','9','\r'] # characters in this line must be in lowercase
# stx relates to '*'
# the controller address is '6','2'
# the command code is '0','1'
# data being transmitted is '0','0','0','0','0','0','0','0'
# checksum is '4','9'
# return is '\r'
buf=[0,0,0,0,0,0,0,0,0,0,0,0]

def hexc2dec(bufp):
        newval=0
        divvy=pow(16,7)
#sets the word size to DDDDDDDD
        for pn in range (1,7):
                vally=ord(bufp[pn])
                if(vally < 97):
                        subby=48
                else:
                        subby=87
                    # ord() converts the character to the ascii number value
                newval+=((ord(bufp[pn])-subby)*divvy)
                divvy/=16
                if(newval > pow(16,8)/2-1):
                        newval=newval-pow(16,8)
                   #distinguishes between positive and negative numbers
        return newval

# change to the port that is connected to the TC-36-25-RS485 Temperature Controller
# this is a sample application used to demonstrate the TC-36-25-RS485 serial protocol
ser=serial.Serial('com7', 115200, timeout=1)
for pn in range(0,16):
        ser.write((bstc[pn]))
        # customer's have noticed an improved communication from the controller with a 4 millisecond delay
        # this delay is optional, however feel free to attempt it in case of any communication problems
for pn in range(0,12):
        buf[pn]=ser.read(1)
        print(buf[pn])
for pn in range(0,16):
        ser.write((bst[pn]))
for pn in range(0,12):
        buf[pn]=ser.read(1)
        print(buf[pn])
ser.close()
temp1=hexc2dec(buf)
print temp1/100.0 #this prints the current read temperature
wait=input("PORT CLOSED")

